put     proc near       ;mode 32b ok
                      
;entree : 
;       plan = numero du plan (<> du bios)
;       x,y = coordonnees
;       chr = characteres a afficher
                                                                
;sortie :
;       affichage du charactere
         
        push eax
        push bx
                           
        cmp x,0                  
        jl fin_put
        cmp x,79
        jg fin_put   
        cmp y,0     
        jl fin_put  
        cmp y,24
        jg fin_put
                      
        call position  
        mov bx,chr     
        mov word ptr [eax],bx
                                                                
fin_put:                                              
        pop bx               
        pop eax              
        ret                                           
        endp put                                      
                     
affichage_ascii proc near       ;mode 32b ok
               
;entree:               
;       edi      = Emplacement de l'ascii
;       Plan    = Numero Du plan a afficher (<> plan du bios)
;       x,y     = Coordonnee o afficher

;       si <32 alors repetition des chr si @ dabord alors couleur en hexa
;       si 254 fin ligne, si 255 fin ascii. le reste est afficher

;sortie:               
;       affichage de l'ascii 
                              
                  
        push ax       
        mov al,x
        mov ah,y       
        push ax   
        push bx                
        push cx     
        push dx  
        push edi 
               
        mov nombre,1
                                               
        mov dl,0       
        mov al,x       
        mov x_depart,al
        dec edi        
boucle1:               
        inc edi        
        mov byte ptr al,ds:[edi]
                             
        cmp al,254               
        je passage_ligne_suivante
        cmp al,255               
        je fin_ascii             
        cmp al,'@'             
        je changement_couleur
retour_couleur:                                
        cmp al,32                              
        jb changement_nombre                                    
                                               
;on affiche                                    
        mov ah,couleur
        mov chr,ax               
        mov cl,nombre        
boucle20:                                                               
        call put             
        dec cl               
        inc x        
        cmp cl,0             
        jne boucle20         
                                               
        jmp boucle1                       
                                 
changement_couleur:              
        inc edi                
        mov al,ds:[edi]                                 
        mov couleur,al           
        mov nombre,1             
        jmp boucle1              
                                 
changement_nombre:               
        mov nombre,al            
        jmp boucle1              
                                 
passage_ligne_suivante:                                                 
        mov al,x_depart          
        mov x,al                 
        inc y                                                   
                              
        jmp boucle1           
                              
fin_ascii:                    
        pop edi                
        pop dx                
        pop cx                 
        pop bx                
        pop ax                
        mov x,al             
        mov y,ah
        pop ax 
                         
        ret                    
                                 
        endp affichage_ascii  

position proc near      ;mode 32b bon
                                                                
;entree:                              
;       plan = n du plan a utilise (<> du bios)
;       x,y = coordonee a trouver
                               
;sortie                         
;       eax = coordonnee dans la memoire
                                
        push ebx                
                                
        xor ebx,ebx             
        xor eax,eax             
                      
        push dx       
        xor dx,dx
        mov dl,plan
        mov ax,4000   
        mul dx
        pop dx
                      
                      
        add eax,0B8000h      ;j ai la coordonnee du plan en eax
                                
        mov bl,y                
        shl ebx,5     
        add eax,ebx             
        shl ebx,2                
        add eax,ebx     
        xor ebx,ebx   
        add bl,x            ;position dans la memoire a la coordonne plan;x;y
        shl ebx,1     
        add eax,ebx   
                      
                                                        
        pop ebx                 
                                
        ret                                                    
                                                               
        endp position

tempo proc near ;       32b ok
;entree:                
;       temp    = temps (temp/18.2 = 1s)
;Sortie:                                
;       ecoulement du temps   
                        
        push eax        
        push bx                  
        push cx                  
        push dx         
                      
        mov bx,temp
                                                     
        mov ax,0h                                    
        int 1ah                                      
        push dx                                      
        dec bx                   
boucle6:                                             
        mov ax,0h                                    
        int 1ah                                      
        pop cx                                       
        push dx                                                 
        cmp cx,dx                                    
        je boucle6                                   
        dec bx                   
        cmp bx,0
        jnl boucle6           
                                                     
        pop dx          ;un pop pour virer le surplus
        pop dx      
        pop cx      
        pop bx      
        pop eax     
                    
        ret                      
        endp tempo 
        
cache_curseur proc near ;       32b ok
        push ax        
        push bx      
        push dx                
        mov ah,02h         
        mov bh,0              
        mov dh,80          
        mov dl,80          
        int 10h            
        pop dx
        pop bx
        pop ax   
        ret               
        endp cache_curseur
             
clear proc near         ;mode 32 bits bon
                              
;entree:                      
;       plan = numero du plan (<> du bios)
                      
;Sortie:                      
;       effacement du plan concernee
                   
        push eax               
        push dx    
        xor eax,eax
                    
        mov al,plan
        shl eax,12
        add eax,0b8000h
              
      	mov dx,0                 
boucle2:
       	mov word ptr [eax],0F00h
     	inc eax               
        inc dx                
     	inc eax      
        inc dx  
     	cmp dx,4000
     	jne boucle2            
                               
        pop dx                 
        pop eax                 
                                
       	ret                     
        endp clear              

synchro proc near       ; 32b ok
        push dx    
        push ax
       
        mov dx,3dah              
                       
;@wait1:                      
;        in al,dx                                               
;        test ax,8h
;        jnz @wait1  
@wait2:           
        in al,dx  
        test ax,8h            
        jnz @wait2
                       
        pop ax    
        pop dx                 
        ret     
                 
        endp synchro
                     
